

// APT-generated file.

package org.carrot2.source.boss;

import java.util.*;
import javax.annotation.*;

// Imported for JavaDoc references mostly.
import org.carrot2.util.attribute.*;

/**
 * Metadata and attributes of the {@link org.carrot2.source.boss.BossNewsSearchService} component. You can use 
 * this descriptor to obtain metadata, such as human readable name and description, about the component 
 * as a whole as well as about its attributes. Using the {@link #attributeBuilder(Map)}
 * you can obtain a builder for type-safe generation of the attribute maps. Please see the
 * <a href="{@docRoot}/overview-summary.html#setting-attributes">main overview</a> for a complete code example. 
 */
@Generated("Generated from org.carrot2.source.boss.BossNewsSearchService")
public final class BossNewsSearchServiceDescriptor implements IBindableDescriptor
{
    /**
     * The component class for which this descriptor was generated. 
     */
    public final String bindableClassName = "org.carrot2.source.boss.BossNewsSearchService";

    /**
     * Attribute prefix used by the component.
     */
    public final String prefix = "BossNewsSearchService";

    /**
     * A one sentence summary of the component. It could be presented as a header of the tool
     * tip of the corresponding UI component.
     */
    public final String title = "Sends queries to Yahoo! Boss News search service";
    
    /**
     * A short label for the component. It can be presented as a label of the
     * corresponding UI component.
     */
    public final String label = "Yahoo Boss News Search Service";

    /**
     * A longer, possibly multi sentence, description of the component. It could be presented
     * as a body of the tool tip of the corresponding UI component.
     */
    public final String description = "Instances of this class are thread-safe. <p> Attributes of this class correspond to Yahoo's documentation (see links below).";

    /**
     * Attributes of the component. Note that only statically reachable fields are included.
     * Additional attributes may be available at run time. 
     */
    public final static Attributes attributes; 

    /**
     * Attributes declared directly by the component.
     */
    private final static Set<AttributeInfo> ownAttributes;

    /**
     * Attributes declared by the component or its superclasses.
     */
    private final static Set<AttributeInfo> allAttributes;

    /**
     * Attributes declared by the component or its superclasses, lookup dictionary 
     * by attribute key.
     */
    private final static Map<String, AttributeInfo> allAttributesByKey;

    /**
     * Attributes declared by the component or its superclasses, lookup dictionary by 
     * attribute's field name.
     */
    private final static Map<String, AttributeInfo> allAttributesByFieldName;

    /**
     * Static initializer for internal collections.
     */
    static
    {
        attributes = new Attributes();

        final Set<AttributeInfo> ownAttrs = new HashSet<AttributeInfo>();
        ownAttrs.add(attributes.serviceURI);
        ownAttrs.add(attributes.age);

        final Set<AttributeInfo> allAttrs = new HashSet<AttributeInfo>();
        allAttrs.add(org.carrot2.source.boss.BossNewsSearchServiceDescriptor.attributes.serviceURI);
        allAttrs.add(org.carrot2.source.boss.BossNewsSearchServiceDescriptor.attributes.age);
        allAttrs.add(org.carrot2.source.boss.BossSearchServiceDescriptor.attributes.appid);
        allAttrs.add(org.carrot2.source.boss.BossSearchServiceDescriptor.attributes.sites);
        allAttrs.add(org.carrot2.source.boss.BossSearchServiceDescriptor.attributes.languageAndRegion);

        allAttributes = Collections.unmodifiableSet(allAttrs);
        ownAttributes = Collections.unmodifiableSet(ownAttrs);
        
        final Map<String, AttributeInfo> allAttrsByKey = new HashMap<String, AttributeInfo>();
        final Map<String, AttributeInfo> allAttrsByFieldName = new HashMap<String, AttributeInfo>();
        for (AttributeInfo ai : allAttrs)
        {
            allAttrsByKey.put(ai.key, ai);
            allAttrsByFieldName.put(ai.fieldName, ai);
        }

        allAttributesByKey = Collections.unmodifiableMap(allAttrsByKey);
        allAttributesByFieldName = Collections.unmodifiableMap(allAttrsByFieldName);
    }

    
    /* Attribute keys. */

    /**
     * Constants for all attribute keys of the {@link org.carrot2.source.boss.BossNewsSearchService} component.
     */
    public static class Keys  extends org.carrot2.source.boss.BossSearchServiceDescriptor.Keys 
    {
        protected Keys() {} 

        /** Attribute key for: {@link org.carrot2.source.boss.BossNewsSearchService#serviceURI}. */
        public static final String SERVICE_URI = "BossNewsSearchService.serviceURI";
        /** Attribute key for: {@link org.carrot2.source.boss.BossNewsSearchService#age}. */
        public static final String AGE = "BossNewsSearchService.age";
    }


    /* Attribute descriptors. */

    /**
     * All attributes of the {@link org.carrot2.source.boss.BossNewsSearchService} component.
     */
    public static final class Attributes
    {
        private Attributes() { /* No public instances. */ }

        /**
         *          */
        public final AttributeInfo serviceURI = 
            new AttributeInfo(
                "BossNewsSearchService.serviceURI",
                "org.carrot2.source.boss.BossNewsSearchService",
                "serviceURI",
                "Boss News search service URI.",
                "Service URI",
                "Boss News search service URI",
                null,
                "Service",
                org.carrot2.util.attribute.AttributeLevel.ADVANCED,
                null
            );

        /**
         *          */
        public final AttributeInfo age = 
            new AttributeInfo(
                "BossNewsSearchService.age",
                "org.carrot2.source.boss.BossNewsSearchService",
                "age",
                "Maximum age of returned news in days. The index stories for 30 days.",
                "Age",
                "Maximum age of returned news in days",
                "The index stories for 30 days.",
                "Results filtering",
                org.carrot2.util.attribute.AttributeLevel.MEDIUM,
                null
            );


    }

    /**
     * Attribute map builder for the  {@link org.carrot2.source.boss.BossNewsSearchService} component. You can use this
     * builder as a type-safe alternative to populating the attribute map using attribute keys.
     */
    public static class AttributeBuilder  extends org.carrot2.source.boss.BossSearchServiceDescriptor.AttributeBuilder 
    {
        /** The attribute map populated by this builder. */
        public final Map<String, Object> map;

        /**
         * Creates a builder backed by the provided map.
         */
        protected AttributeBuilder(Map<String, Object> map)
        {
             super(map); 
            this.map = map;
        }


        
        
        /**
         * Boss News search service URI.
         * 
         * @see org.carrot2.source.boss.BossNewsSearchService#serviceURI 
         */
        public AttributeBuilder serviceURI(java.lang.String value)
        {
            map.put("BossNewsSearchService.serviceURI", value);
            return this;
        }
        
        
        
        
        
        
        
        /**
         * Maximum age of returned news in days. The index stories for 30 days.
         * 
         * @see org.carrot2.source.boss.BossNewsSearchService#age 
         */
        public AttributeBuilder age(int value)
        {
            map.put("BossNewsSearchService.age", value);
            return this;
        }
        
        
        
        
        
    }

    /**
     * Creates an attribute map builder for the component. You can use this
     * builder as a type-safe alternative to populating the attribute map using attribute keys.
     * 
     * @param attributeValues An existing map which should be used to collect attribute values. 
     *        Attribute values set by this builder will be added to the provided map, overwriting
     *        previously defined mappings, if any.
     */
    public static AttributeBuilder attributeBuilder(Map<String, Object> attributeValues)
    {
        return new AttributeBuilder(attributeValues);
    }
    
    /* IBindableDescriptor */

    @Override 
    public String getPrefix()
    {
        return prefix;
    }

    @Override 
    public String getTitle()
    {
        return title;
    }
    
    @Override 
    public String getLabel()      
    { 
        return label;
    }
    
    @Override 
    public String getDescription() 
    { 
        return description; 
    }

    @Override 
    public Set<AttributeInfo> getOwnAttributes()
    { 
        return ownAttributes;
    }

    @Override 
    public Set<AttributeInfo> getAttributes()
    {
        return allAttributes;
    }

    @Override 
    public Map<String, AttributeInfo> getAttributesByKey()
    {
        return allAttributesByKey;
    }

    @Override 
    public Map<String, AttributeInfo> getAttributesByFieldName()
    {
        return allAttributesByFieldName;
    }
}
