

// APT-generated file.

package org.carrot2.source.boss;

import java.util.*;
import javax.annotation.*;

// Imported for JavaDoc references mostly.
import org.carrot2.util.attribute.*;

/**
 * Metadata and attributes of the {@link org.carrot2.source.boss.BossWebSearchService} component. You can use 
 * this descriptor to obtain metadata, such as human readable name and description, about the component 
 * as a whole as well as about its attributes. Using the {@link #attributeBuilder(Map)}
 * you can obtain a builder for type-safe generation of the attribute maps. Please see the
 * <a href="{@docRoot}/overview-summary.html#setting-attributes">main overview</a> for a complete code example. 
 */
@Generated("Generated from org.carrot2.source.boss.BossWebSearchService")
public final class BossWebSearchServiceDescriptor implements IBindableDescriptor
{
    /**
     * The component class for which this descriptor was generated. 
     */
    public final String bindableClassName = "org.carrot2.source.boss.BossWebSearchService";

    /**
     * Attribute prefix used by the component.
     */
    public final String prefix = "BossWebSearchService";

    /**
     * A one sentence summary of the component. It could be presented as a header of the tool
     * tip of the corresponding UI component.
     */
    public final String title = "Sends queries to Yahoo! Boss Web search service";
    
    /**
     * A short label for the component. It can be presented as a label of the
     * corresponding UI component.
     */
    public final String label = "Yahoo Boss Web Search Service";

    /**
     * A longer, possibly multi sentence, description of the component. It could be presented
     * as a body of the tool tip of the corresponding UI component.
     */
    public final String description = "Instances of this class are thread-safe. <p> Attributes of this class correspond to Yahoo's documentation (see links below).";

    /**
     * Attributes of the component. Note that only statically reachable fields are included.
     * Additional attributes may be available at run time. 
     */
    public final static Attributes attributes; 

    /**
     * Attributes declared directly by the component.
     */
    private final static Set<AttributeInfo> ownAttributes;

    /**
     * Attributes declared by the component or its superclasses.
     */
    private final static Set<AttributeInfo> allAttributes;

    /**
     * Attributes declared by the component or its superclasses, lookup dictionary 
     * by attribute key.
     */
    private final static Map<String, AttributeInfo> allAttributesByKey;

    /**
     * Attributes declared by the component or its superclasses, lookup dictionary by 
     * attribute's field name.
     */
    private final static Map<String, AttributeInfo> allAttributesByFieldName;

    /**
     * Static initializer for internal collections.
     */
    static
    {
        attributes = new Attributes();

        final Set<AttributeInfo> ownAttrs = new HashSet<AttributeInfo>();
        ownAttrs.add(attributes.serviceURI);
        ownAttrs.add(attributes.filter);
        ownAttrs.add(attributes.type);

        final Set<AttributeInfo> allAttrs = new HashSet<AttributeInfo>();
        allAttrs.add(org.carrot2.source.boss.BossWebSearchServiceDescriptor.attributes.serviceURI);
        allAttrs.add(org.carrot2.source.boss.BossWebSearchServiceDescriptor.attributes.filter);
        allAttrs.add(org.carrot2.source.boss.BossWebSearchServiceDescriptor.attributes.type);
        allAttrs.add(org.carrot2.source.boss.BossSearchServiceDescriptor.attributes.appid);
        allAttrs.add(org.carrot2.source.boss.BossSearchServiceDescriptor.attributes.sites);
        allAttrs.add(org.carrot2.source.boss.BossSearchServiceDescriptor.attributes.languageAndRegion);

        allAttributes = Collections.unmodifiableSet(allAttrs);
        ownAttributes = Collections.unmodifiableSet(ownAttrs);
        
        final Map<String, AttributeInfo> allAttrsByKey = new HashMap<String, AttributeInfo>();
        final Map<String, AttributeInfo> allAttrsByFieldName = new HashMap<String, AttributeInfo>();
        for (AttributeInfo ai : allAttrs)
        {
            allAttrsByKey.put(ai.key, ai);
            allAttrsByFieldName.put(ai.fieldName, ai);
        }

        allAttributesByKey = Collections.unmodifiableMap(allAttrsByKey);
        allAttributesByFieldName = Collections.unmodifiableMap(allAttrsByFieldName);
    }

    
    /* Attribute keys. */

    /**
     * Constants for all attribute keys of the {@link org.carrot2.source.boss.BossWebSearchService} component.
     */
    public static class Keys  extends org.carrot2.source.boss.BossSearchServiceDescriptor.Keys 
    {
        protected Keys() {} 

        /** Attribute key for: {@link org.carrot2.source.boss.BossWebSearchService#serviceURI}. */
        public static final String SERVICE_URI = "BossWebSearchService.serviceURI";
        /** Attribute key for: {@link org.carrot2.source.boss.BossWebSearchService#filter}. */
        public static final String FILTER = "BossWebSearchService.filter";
        /** Attribute key for: {@link org.carrot2.source.boss.BossWebSearchService#type}. */
        public static final String TYPE = "BossWebSearchService.type";
    }


    /* Attribute descriptors. */

    /**
     * All attributes of the {@link org.carrot2.source.boss.BossWebSearchService} component.
     */
    public static final class Attributes
    {
        private Attributes() { /* No public instances. */ }

        /**
         *          */
        public final AttributeInfo serviceURI = 
            new AttributeInfo(
                "BossWebSearchService.serviceURI",
                "org.carrot2.source.boss.BossWebSearchService",
                "serviceURI",
                "Boss Web search service URI. Specifies the URI at which Yahoo Boss Web Search API\nis available. The <code>${query}</code> place holder will be replaced with the\nURL-encoded text of the processed query.",
                "Service URI",
                "Boss Web search service URI",
                "Specifies the URI at which Yahoo Boss Web Search API is available. The <code>${query}</code> place holder will be replaced with the URL-encoded text of the processed query.",
                "Service",
                org.carrot2.util.attribute.AttributeLevel.ADVANCED,
                null
            );

        /**
         *          */
        public final AttributeInfo filter = 
            new AttributeInfo(
                "BossWebSearchService.filter",
                "org.carrot2.source.boss.BossWebSearchService",
                "filter",
                "Filters out adult or hate content. Must be a comma-separated list of content types\nto filter out.\n<p>\nThe following content types are supported:\n</p>\n<table>\n<thead>\n<tr>\n<th align=\"left\">Value</th> <th align=\"left\">Content</th>\n</tr>\n</thead> <tbody>\n<tr>\n<td><code>-porn</code></td>\n<td>Filters out adult content</td>\n</tr>\n<tr>\n<td><code>-hate</code></td>\n<td>Filters out hate content</td>\n</tr>\n</tbody>\n</table>\n<p>\nAdult content filtering is supported for all languages, hate content filtering is\nsupported for English only.\n</p>",
                "Content filter",
                "Filters out adult or hate content",
                "Must be a comma-separated list of content types to filter out. <p> The following content types are supported: </p> <table> <thead> <tr> <th align=\"left\">Value</th> <th align=\"left\">Content</th> </tr> </thead> <tbody> <tr> <td><code>-porn</code></td> <td>Filters out adult content</td> </tr> <tr> <td><code>-hate</code></td> <td>Filters out hate content</td> </tr> </tbody> </table> <p> Adult content filtering is supported for all languages, hate content filtering is supported for English only. </p>",
                "Results filtering",
                org.carrot2.util.attribute.AttributeLevel.MEDIUM,
                null
            );

        /**
         *          */
        public final AttributeInfo type = 
            new AttributeInfo(
                "BossWebSearchService.type",
                "org.carrot2.source.boss.BossWebSearchService",
                "type",
                "Restricts search to documents of the specified types. Must be a comma-separated\nlist of the required document types or type groups.\n<p>\nThe following document types are supported:\n</p>\n<table>\n<thead>\n<tr>\n<th align=\"left\">Value</th> <th align=\"left\">Document type</th>\n</tr>\n</thead> <tbody>\n<tr>\n<td><code>html</code></td>\n<td>HTML documents</td>\n</tr>\n<tr>\n<td><code>text</code></td>\n<td>Plain text documents</td>\n</tr>\n<tr>\n<td><code>pdf</code></td>\n<td>Portable Document Format documents</td>\n</tr>\n<tr>\n<td><code>xl</code></td>\n<td>Microsoft Excel documents</td>\n</tr>\n<tr>\n<td><code>msword</code></td>\n<td>Microsoft Word documents</td>\n</tr>\n<tr>\n<td><code>ppt</code></td>\n<td>Microsoft Power Point documents</td>\n</tr>\n</tbody>\n</table>\n<p>\nThe following document type groups are supported:\n</p>\n<table>\n<thead>\n<tr>\n<th align=\"left\">Value</th> <th align=\"left\">Document type groups</th>\n</tr>\n</thead> <tbody>\n<tr>\n<td><code>msoffice</code></td>\n<td>All Microsoft Office documents (<code>xl</code>, <code>msword</code>,\n<code>ppt</code>)</td>\n</tr>\n<tr>\n<td><code>nohtml</code></td>\n<td>Anything else than HTML documents (<code>text</code>, <code>pdf</code>,\n<code>xl</code>, <code>msword</code>, <code>ppt</code>)</td>\n</tr>\n</tbody>\n</table>\n<p>\nYou can also specify a format group and then exclude an item:\n<code>type=msoffice,-ppt</code>.\n</p>",
                "Type filter",
                "Restricts search to documents of the specified types",
                "Must be a comma-separated list of the required document types or type groups. <p> The following document types are supported: </p> <table> <thead> <tr> <th align=\"left\">Value</th> <th align=\"left\">Document type</th> </tr> </thead> <tbody> <tr> <td><code>html</code></td> <td>HTML documents</td> </tr> <tr> <td><code>text</code></td> <td>Plain text documents</td> </tr> <tr> <td><code>pdf</code></td> <td>Portable Document Format documents</td> </tr> <tr> <td><code>xl</code></td> <td>Microsoft Excel documents</td> </tr> <tr> <td><code>msword</code></td> <td>Microsoft Word documents</td> </tr> <tr> <td><code>ppt</code></td> <td>Microsoft Power Point documents</td> </tr> </tbody> </table> <p> The following document type groups are supported: </p> <table> <thead> <tr> <th align=\"left\">Value</th> <th align=\"left\">Document type groups</th> </tr> </thead> <tbody> <tr> <td><code>msoffice</code></td> <td>All Microsoft Office documents (<code>xl</code>, <code>msword</code>, <code>ppt</code>)</td> </tr> <tr> <td><code>nohtml</code></td> <td>Anything else than HTML documents (<code>text</code>, <code>pdf</code>, <code>xl</code>, <code>msword</code>, <code>ppt</code>)</td> </tr> </tbody> </table> <p> You can also specify a format group and then exclude an item: <code>type=msoffice,-ppt</code>. </p>",
                "Results filtering",
                org.carrot2.util.attribute.AttributeLevel.ADVANCED,
                null
            );


    }

    /**
     * Attribute map builder for the  {@link org.carrot2.source.boss.BossWebSearchService} component. You can use this
     * builder as a type-safe alternative to populating the attribute map using attribute keys.
     */
    public static class AttributeBuilder  extends org.carrot2.source.boss.BossSearchServiceDescriptor.AttributeBuilder 
    {
        /** The attribute map populated by this builder. */
        public final Map<String, Object> map;

        /**
         * Creates a builder backed by the provided map.
         */
        protected AttributeBuilder(Map<String, Object> map)
        {
             super(map); 
            this.map = map;
        }


        
        
        /**
         * Boss Web search service URI. Specifies the URI at which Yahoo Boss Web Search API
is available. The <code>${query}</code> place holder will be replaced with the
URL-encoded text of the processed query.
         * 
         * @see org.carrot2.source.boss.BossWebSearchService#serviceURI 
         */
        public AttributeBuilder serviceURI(java.lang.String value)
        {
            map.put("BossWebSearchService.serviceURI", value);
            return this;
        }
        
        
        
        
        
        
        
        /**
         * Filters out adult or hate content. Must be a comma-separated list of content types
to filter out.
<p>
The following content types are supported:
</p>
<table>
<thead>
<tr>
<th align="left">Value</th> <th align="left">Content</th>
</tr>
</thead> <tbody>
<tr>
<td><code>-porn</code></td>
<td>Filters out adult content</td>
</tr>
<tr>
<td><code>-hate</code></td>
<td>Filters out hate content</td>
</tr>
</tbody>
</table>
<p>
Adult content filtering is supported for all languages, hate content filtering is
supported for English only.
</p>
         * 
         * @see org.carrot2.source.boss.BossWebSearchService#filter 
         */
        public AttributeBuilder filter(org.carrot2.source.boss.BossWebSearchService.OffensiveContentFilter value)
        {
            map.put("BossWebSearchService.filter", value);
            return this;
        }
        
        
        
        /**
         * Filters out adult or hate content. Must be a comma-separated list of content types
to filter out.
<p>
The following content types are supported:
</p>
<table>
<thead>
<tr>
<th align="left">Value</th> <th align="left">Content</th>
</tr>
</thead> <tbody>
<tr>
<td><code>-porn</code></td>
<td>Filters out adult content</td>
</tr>
<tr>
<td><code>-hate</code></td>
<td>Filters out hate content</td>
</tr>
</tbody>
</table>
<p>
Adult content filtering is supported for all languages, hate content filtering is
supported for English only.
</p>
         * 
         * @see org.carrot2.source.boss.BossWebSearchService#filter
         */
        public AttributeBuilder filter(Class<? extends org.carrot2.source.boss.BossWebSearchService.OffensiveContentFilter> clazz)
        {
            map.put("BossWebSearchService.filter", clazz);
            return this;
        }
        
        
        
        
        
        /**
         * Restricts search to documents of the specified types. Must be a comma-separated
list of the required document types or type groups.
<p>
The following document types are supported:
</p>
<table>
<thead>
<tr>
<th align="left">Value</th> <th align="left">Document type</th>
</tr>
</thead> <tbody>
<tr>
<td><code>html</code></td>
<td>HTML documents</td>
</tr>
<tr>
<td><code>text</code></td>
<td>Plain text documents</td>
</tr>
<tr>
<td><code>pdf</code></td>
<td>Portable Document Format documents</td>
</tr>
<tr>
<td><code>xl</code></td>
<td>Microsoft Excel documents</td>
</tr>
<tr>
<td><code>msword</code></td>
<td>Microsoft Word documents</td>
</tr>
<tr>
<td><code>ppt</code></td>
<td>Microsoft Power Point documents</td>
</tr>
</tbody>
</table>
<p>
The following document type groups are supported:
</p>
<table>
<thead>
<tr>
<th align="left">Value</th> <th align="left">Document type groups</th>
</tr>
</thead> <tbody>
<tr>
<td><code>msoffice</code></td>
<td>All Microsoft Office documents (<code>xl</code>, <code>msword</code>,
<code>ppt</code>)</td>
</tr>
<tr>
<td><code>nohtml</code></td>
<td>Anything else than HTML documents (<code>text</code>, <code>pdf</code>,
<code>xl</code>, <code>msword</code>, <code>ppt</code>)</td>
</tr>
</tbody>
</table>
<p>
You can also specify a format group and then exclude an item:
<code>type=msoffice,-ppt</code>.
</p>
         * 
         * @see org.carrot2.source.boss.BossWebSearchService#type 
         */
        public AttributeBuilder type(java.lang.String value)
        {
            map.put("BossWebSearchService.type", value);
            return this;
        }
        
        
        
        
        
    }

    /**
     * Creates an attribute map builder for the component. You can use this
     * builder as a type-safe alternative to populating the attribute map using attribute keys.
     * 
     * @param attributeValues An existing map which should be used to collect attribute values. 
     *        Attribute values set by this builder will be added to the provided map, overwriting
     *        previously defined mappings, if any.
     */
    public static AttributeBuilder attributeBuilder(Map<String, Object> attributeValues)
    {
        return new AttributeBuilder(attributeValues);
    }
    
    /* IBindableDescriptor */

    @Override 
    public String getPrefix()
    {
        return prefix;
    }

    @Override 
    public String getTitle()
    {
        return title;
    }
    
    @Override 
    public String getLabel()      
    { 
        return label;
    }
    
    @Override 
    public String getDescription() 
    { 
        return description; 
    }

    @Override 
    public Set<AttributeInfo> getOwnAttributes()
    { 
        return ownAttributes;
    }

    @Override 
    public Set<AttributeInfo> getAttributes()
    {
        return allAttributes;
    }

    @Override 
    public Map<String, AttributeInfo> getAttributesByKey()
    {
        return allAttributesByKey;
    }

    @Override 
    public Map<String, AttributeInfo> getAttributesByFieldName()
    {
        return allAttributesByFieldName;
    }
}
