

// APT-generated file.

package org.carrot2.text.preprocessing.pipeline;

import java.util.*;
import javax.annotation.*;

// Imported for JavaDoc references mostly.
import org.carrot2.util.attribute.*;

/**
 * Metadata and attributes of the {@link org.carrot2.text.preprocessing.pipeline.BasicPreprocessingPipeline} component. You can use 
 * this descriptor to obtain metadata, such as human readable name and description, about the component 
 * as a whole as well as about its attributes. Using the {@link #attributeBuilder(Map)}
 * you can obtain a builder for type-safe generation of the attribute maps. Please see the
 * <a href="{@docRoot}/overview-summary.html#setting-attributes">main overview</a> for a complete code example. 
 */
@Generated("Generated from org.carrot2.text.preprocessing.pipeline.BasicPreprocessingPipeline")
public final class BasicPreprocessingPipelineDescriptor implements IBindableDescriptor
{
    /**
     * The component class for which this descriptor was generated. 
     */
    public final String bindableClassName = "org.carrot2.text.preprocessing.pipeline.BasicPreprocessingPipeline";

    /**
     * Attribute prefix used by the component.
     */
    public final String prefix = "PreprocessingPipeline";

    /**
     * A one sentence summary of the component. It could be presented as a header of the tool
     * tip of the corresponding UI component.
     */
    public final String title = "Performs basic preprocessing steps on the provided documents";
    
    /**
     * A short label for the component. It can be presented as a label of the
     * corresponding UI component.
     */
    public final String label = "";

    /**
     * A longer, possibly multi sentence, description of the component. It could be presented
     * as a body of the tool tip of the corresponding UI component.
     */
    public final String description = "The preprocessing consists of the following steps: <ol> <li><code>Tokenizer.tokenize(PreprocessingContext)</code></li> <li><code>CaseNormalizer.normalize(PreprocessingContext)</code></li> <li><code>LanguageModelStemmer.stem(PreprocessingContext)</code></li> <li><code>StopListMarker.mark(PreprocessingContext)</code></li> </ol>";

    /**
     * Attributes of the component. Note that only statically reachable fields are included.
     * Additional attributes may be available at run time. 
     */
    public final static Attributes attributes; 

    /**
     * Attributes declared directly by the component.
     */
    private final static Set<AttributeInfo> ownAttributes;

    /**
     * Attributes declared by the component or its superclasses.
     */
    private final static Set<AttributeInfo> allAttributes;

    /**
     * Attributes declared by the component or its superclasses, lookup dictionary 
     * by attribute key.
     */
    private final static Map<String, AttributeInfo> allAttributesByKey;

    /**
     * Attributes declared by the component or its superclasses, lookup dictionary by 
     * attribute's field name.
     */
    private final static Map<String, AttributeInfo> allAttributesByFieldName;

    /**
     * Static initializer for internal collections.
     */
    static
    {
        attributes = new Attributes();

        final Set<AttributeInfo> ownAttrs = new HashSet<AttributeInfo>();
        ownAttrs.add(attributes.languageModelFactory);

        final Set<AttributeInfo> allAttrs = new HashSet<AttributeInfo>();
        allAttrs.add(org.carrot2.text.preprocessing.pipeline.BasicPreprocessingPipelineDescriptor.attributes.languageModelFactory);

        allAttributes = Collections.unmodifiableSet(allAttrs);
        ownAttributes = Collections.unmodifiableSet(ownAttrs);
        
        final Map<String, AttributeInfo> allAttrsByKey = new HashMap<String, AttributeInfo>();
        final Map<String, AttributeInfo> allAttrsByFieldName = new HashMap<String, AttributeInfo>();
        for (AttributeInfo ai : allAttrs)
        {
            allAttrsByKey.put(ai.key, ai);
            allAttrsByFieldName.put(ai.fieldName, ai);
        }

        allAttributesByKey = Collections.unmodifiableMap(allAttrsByKey);
        allAttributesByFieldName = Collections.unmodifiableMap(allAttrsByFieldName);
    }

    
    /* Attribute keys. */

    /**
     * Constants for all attribute keys of the {@link org.carrot2.text.preprocessing.pipeline.BasicPreprocessingPipeline} component.
     */
    public static class Keys 
    {
        protected Keys() {} 

        /** Attribute key for: {@link org.carrot2.text.preprocessing.pipeline.BasicPreprocessingPipeline#languageModelFactory}. */
        public static final String LANGUAGE_MODEL_FACTORY = "PreprocessingPipeline.languageModelFactory";
    }


    /* Attribute descriptors. */

    /**
     * All attributes of the {@link org.carrot2.text.preprocessing.pipeline.BasicPreprocessingPipeline} component.
     */
    public static final class Attributes
    {
        private Attributes() { /* No public instances. */ }

        /**
         *          */
        public final AttributeInfo languageModelFactory = 
            new AttributeInfo(
                "PreprocessingPipeline.languageModelFactory",
                "org.carrot2.text.preprocessing.pipeline.BasicPreprocessingPipeline",
                "languageModelFactory",
                "Language model factory. Creates the language model to be used by the\nclustering algorithm. The language models provides the lexical resources required\nto perform clustering, including stop words and a word stemming algorithm.",
                null,
                "Language model factory",
                "Creates the language model to be used by the clustering algorithm. The language models provides the lexical resources required to perform clustering, including stop words and a word stemming algorithm.",
                "Preprocessing",
                org.carrot2.util.attribute.AttributeLevel.ADVANCED,
                null
            );


        /**
         * Attributes of the nested {@link org.carrot2.text.preprocessing.Tokenizer} component.
         */
        public final org.carrot2.text.preprocessing.TokenizerDescriptor.Attributes tokenizer =
            org.carrot2.text.preprocessing.TokenizerDescriptor.attributes;

        /**
         * Attributes of the nested {@link org.carrot2.text.preprocessing.CaseNormalizer} component.
         */
        public final org.carrot2.text.preprocessing.CaseNormalizerDescriptor.Attributes caseNormalizer =
            org.carrot2.text.preprocessing.CaseNormalizerDescriptor.attributes;

        /**
         * Attributes of the nested {@link org.carrot2.text.preprocessing.LanguageModelStemmer} component.
         */
        public final org.carrot2.text.preprocessing.LanguageModelStemmerDescriptor.Attributes languageModelStemmer =
            org.carrot2.text.preprocessing.LanguageModelStemmerDescriptor.attributes;

        /**
         * Attributes of the nested {@link org.carrot2.text.preprocessing.StopListMarker} component.
         */
        public final org.carrot2.text.preprocessing.StopListMarkerDescriptor.Attributes stopListMarker =
            org.carrot2.text.preprocessing.StopListMarkerDescriptor.attributes;

    }

    /**
     * Attribute map builder for the  {@link org.carrot2.text.preprocessing.pipeline.BasicPreprocessingPipeline} component. You can use this
     * builder as a type-safe alternative to populating the attribute map using attribute keys.
     */
    public static class AttributeBuilder 
    {
        /** The attribute map populated by this builder. */
        public final Map<String, Object> map;

        /**
         * Creates a builder backed by the provided map.
         */
        protected AttributeBuilder(Map<String, Object> map)
        {
            
            this.map = map;
        }


        
        
        /**
         * Language model factory. Creates the language model to be used by the
clustering algorithm. The language models provides the lexical resources required
to perform clustering, including stop words and a word stemming algorithm.
         * 
         * @see org.carrot2.text.preprocessing.pipeline.BasicPreprocessingPipeline#languageModelFactory 
         */
        public AttributeBuilder languageModelFactory(org.carrot2.text.linguistic.ILanguageModelFactory value)
        {
            map.put("PreprocessingPipeline.languageModelFactory", value);
            return this;
        }
        
        
        
        /**
         * Language model factory. Creates the language model to be used by the
clustering algorithm. The language models provides the lexical resources required
to perform clustering, including stop words and a word stemming algorithm.
         * 
         * @see org.carrot2.text.preprocessing.pipeline.BasicPreprocessingPipeline#languageModelFactory
         */
        public AttributeBuilder languageModelFactory(Class<? extends org.carrot2.text.linguistic.ILanguageModelFactory> clazz)
        {
            map.put("PreprocessingPipeline.languageModelFactory", clazz);
            return this;
        }
        
        
        
        /**
         * Returns an attribute builder for the nested
         * {@link org.carrot2.text.preprocessing.Tokenizer} component, backed by the same attribute map
         * as the current builder.
         */
        public org.carrot2.text.preprocessing.TokenizerDescriptor.AttributeBuilder tokenizer()
        {
            return org.carrot2.text.preprocessing.TokenizerDescriptor.attributeBuilder(map);
        }

        /**
         * Returns an attribute builder for the nested
         * {@link org.carrot2.text.preprocessing.CaseNormalizer} component, backed by the same attribute map
         * as the current builder.
         */
        public org.carrot2.text.preprocessing.CaseNormalizerDescriptor.AttributeBuilder caseNormalizer()
        {
            return org.carrot2.text.preprocessing.CaseNormalizerDescriptor.attributeBuilder(map);
        }

        /**
         * Returns an attribute builder for the nested
         * {@link org.carrot2.text.preprocessing.LanguageModelStemmer} component, backed by the same attribute map
         * as the current builder.
         */
        public org.carrot2.text.preprocessing.LanguageModelStemmerDescriptor.AttributeBuilder languageModelStemmer()
        {
            return org.carrot2.text.preprocessing.LanguageModelStemmerDescriptor.attributeBuilder(map);
        }

        /**
         * Returns an attribute builder for the nested
         * {@link org.carrot2.text.preprocessing.StopListMarker} component, backed by the same attribute map
         * as the current builder.
         */
        public org.carrot2.text.preprocessing.StopListMarkerDescriptor.AttributeBuilder stopListMarker()
        {
            return org.carrot2.text.preprocessing.StopListMarkerDescriptor.attributeBuilder(map);
        }

    }

    /**
     * Creates an attribute map builder for the component. You can use this
     * builder as a type-safe alternative to populating the attribute map using attribute keys.
     * 
     * @param attributeValues An existing map which should be used to collect attribute values. 
     *        Attribute values set by this builder will be added to the provided map, overwriting
     *        previously defined mappings, if any.
     */
    public static AttributeBuilder attributeBuilder(Map<String, Object> attributeValues)
    {
        return new AttributeBuilder(attributeValues);
    }
    
    /* IBindableDescriptor */

    @Override 
    public String getPrefix()
    {
        return prefix;
    }

    @Override 
    public String getTitle()
    {
        return title;
    }
    
    @Override 
    public String getLabel()      
    { 
        return label;
    }
    
    @Override 
    public String getDescription() 
    { 
        return description; 
    }

    @Override 
    public Set<AttributeInfo> getOwnAttributes()
    { 
        return ownAttributes;
    }

    @Override 
    public Set<AttributeInfo> getAttributes()
    {
        return allAttributes;
    }

    @Override 
    public Map<String, AttributeInfo> getAttributesByKey()
    {
        return allAttributesByKey;
    }

    @Override 
    public Map<String, AttributeInfo> getAttributesByFieldName()
    {
        return allAttributesByFieldName;
    }
}
